#
# Copyright (c) 2013-2023 NIBIO.
#
# This file is part of VIPSWeb 
# (see https://gitlab.nibio.no/VIPS/VIPSWeb).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
#

#from django.db import models
from django.conf import settings
import requests

# Create your models here.
class VipsLogicUser:
    def __init__(self,
                 user_id,
                 first_name,
                 last_name,
                 email,
                 organization_id,
                 vips_logic_roles
                 ):
        self.user_id = user_id
        self.first_name = first_name
        self.last_name = last_name
        self.email = email
        self.organization_id = organization_id
        self.vips_logic_roles = vips_logic_roles
    
    @staticmethod
    def get_instance_from_dict(the_dict):
        return VipsLogicUser(
                             the_dict.get("userId", None),
                             the_dict.get("firstName", None),
                             the_dict.get("lastName", None),
                             the_dict.get("email", None),
                             the_dict.get("organizationId", None),
                             the_dict.get("vipsLogicRoles", None)
                             )
        
    
    @staticmethod
    def find_by_uuid(user_uuid):
        request_result = requests.get("%s://%s/rest/user/uuid/%s" % (settings.VIPSLOGIC_PROTOCOL, settings.VIPSLOGIC_SERVER_NAME,user_uuid))
        if request_result.status_code == 200:
            #return VipsLogicUser.get_instance_from_dict(request_result.json())
            #print request_result.json()
            return request_result.json()
        else:
            return None 
